#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<time.h>
#include<malloc.h>
#include "../ukk_lib/win32/ukk.h"

#define SIZE 1048576
char text[SIZE+5];
node_st *root=0;

//     
char *RefName(node_st *node,char *buff)
{
	if(node==root) strcpy(buff,"<root>  ");
	else sprintf(buff,"%08x",node);
	return buff;
}

//    
// node  -  
// depth -   
// all   - true     
void Show(node_st *node,int depth=0)
{
	int n; char buff1[10],buff2[10];
	char* start,*end,*it; 
	if(!node) return;
	link_st *link=node->links; 
	if(!link) _asm { int 3 }
	while(link) {
		start=link->first;
		end  =link->last;  
		if(!end) end=link->str->end;
		for(n=0; n<depth; n++) putchar('.');
		for(it=start; *it && it<end; it++) putchar(*it);
		for(n=depth+it-link->first; n<30; n++) putchar(' ');
		printf("n:%s  l:%x  s:%s\n",RefName(node,buff1),link,RefName(node->suff,buff2));
		Show(link->node,depth+(end-start));
		link=link->next;
	}
}

//  
// lines -    
// text  -    (0 -   )
bool Test(int lines=1,char *text=0)
{
	int n,m,size,pass;
	char *ref;
	char **array=(char**)_alloca(lines*sizeof(char*));
	for(pass=0; pass<lines; pass++) {
		if(lines==1 && text) array[pass]=text,size=strlen(text);
		else {
			size=5+rand()%70;
			array[pass]=(char*)_alloca(size+1);
			for(n=0; n<size; n++) array[pass][n]='0'+rand()%10; array[pass][n]=0;
		}
		if(size>75) printf("test [size=%d]...\n",size);
		else {
			if(lines>1) printf("t%d: %s\n",pass,array[pass]);
			else printf("t: %s\n",array[pass]);
		}
		MakeTree(array[pass],size);
	}
	for(pass=0; pass<lines; pass++) {
		size=strlen(array[pass]);
		for(n=0; n<size; n++) {
			ref=Find(&array[pass][n],size-n,0);
			if(!ref) {
				printf("lost: ");
				for(m=0; array[pass][n+m]; m++) {
					putchar(array[pass][n+m]);
					if(m==3) {printf("...");break;}
				}
				putchar('\n'); putchar('\a');
				return true;
			}
		}
	}
	ClearTree();
	return false;
}


#define LSIZE 100000	//   

inline bool Copy(char *buff,int index,int copy_size,int buff_size)
{
	bool res=false;
	buff_size-=index;
	if(copy_size>=buff_size) copy_size=buff_size,res=true;
	strncpy(buff+index,buff,copy_size);
	return res;
}

//   - 
void F(char *buff,int size)
{
	int s1,s2,index;
	strcpy(buff,"ab");
	s1=1; s2=index=2;
	for(;;) {
		if(Copy(buff,index,s1,size)) break;
		index+=s1;
		s1=s2;
		s2=index;
	}
	buff[size]=0;
}

//  
void AllTest()
{
	char buff[LSIZE+1]; int _,i1,i2;
	//    
	memset(buff,'a',LSIZE); buff[LSIZE]=0; if(Test(1,buff)) return;	
	//    
	for(_=0; _<LSIZE; _++) buff[_]="ABCDE"[_%5]; buff[_]=0; 
	if(Test(1,buff)) return; 
	//      
	for(_=0; _<100; _++) buff[rand()%LSIZE]='x'; if(Test(1,buff)) return;
	// ...   
	for(_=0; _<100; _++) {
		i1=rand()%LSIZE;
		i2=rand()%LSIZE;
		char t=buff[i1]; buff[i1]=buff[i2]; buff[i2]=t;
	}
	if(Test(1,buff)) return; 
	//   
	i1=0; F(buff,LSIZE); buff[i1]=0;
	if(Test(1,buff)) return;
	//    
	for(_=0; _<10000; _++) if(Test(1)) return;
	//     
	if(Test(10000)) return;
	//    
	for(_=0; _<10000; _++) if(Test(2)) return;
	for(_=0; _<1000; _++) if(Test(3)) return;
}


int main()
{
	int _; char *ref; str_st *id;
	MemoryInit();
//=====   
	printf("text: 133575351\n");
	root=MakeTree("133575351");
	SortLinks();
	Show(root,0);
	printf("nodes count: %d\n",CalcNodes());
	printf("links count: %d\n",CalcLinks());
	printf("leafs count: %d\n",CalcLeafs());
	printf("leafs size: %d\n",CalcLeafsSize());
	printf("[press enter]\n"); getchar();
	ClearTree();
//=====     
	printf("text: abaabx/4872587\n");
	     MakeTree("4872587");
	root=MakeTree("abaabx");
	Show(root,0);
	printf("[press enter]\n"); getchar();
	ClearTree();
//=====   
	printf("wait...\n");
	for(_=0; _<SIZE; _++) text[_]='0'+rand()%10; text[_]=0;
	clock_t t1=clock();
	id=AddString(text);
	root=UpdateString(id,SIZE);
	clock_t t2=clock();
	printf("text size: %d\n",strlen(text));
	printf("work time: %dms\n",t2-t1);
	printf("nodes count: %d\n",CalcNodes());
	printf("links count: %d\n",CalcLinks());
	printf("leafs count: %d\n",CalcLeafs());
	_=MaxReentrant(id,&ref);
	printf("max substring (size=%d): ",_);
	while(_--) putchar(*ref++); putchar('\n');
	printf("[press enter]\n"); getchar();
	ClearTree();
//===== 
	AllTest();
	printf("[press enter]\n"); getchar();
	return 0;
}




