public CalcPages as '_CalcPages@0'
extrn '__imp__LocalAlloc@8' as LocalAlloc:dword
extrn '__imp__LocalFree@4'  as LocalFree:dword

PAGE_SIZE	equ	4096	;  


;.data?
	BankList	dd	?	;  
	OldBank 	dd	?	;  
	FreeLinks	dd	?	;
	FreeNodes	dd	?	;
	UseCount	dd	?	;      
	OldCount	dd	?	;     

;
;   
MemoryInit:
      xor     eax,eax
      mov     edi,BankList
      mov     [TreeRoot],eax
      mov     [LastString],eax
      mov     [isSort],eax
      stosd
      stosd
      stosd
      stosd
      mov     eax,PAGE_SIZE
      stosd
      stosd
      ret


; >> eax = 0
NewBank:
	push	ebx
	push	ecx
	push	edx
	invoke	LocalAlloc,LMEM_FIXED,PAGE_SIZE
;               invoke  VirtualAlloc,0,PAGE_SIZE,MEM_COMMIT,PAGE_READWRITE
	mov	ecx,[UseCount]
	mov	ebx,[BankList]
	mov	[OldBank],ebx
	mov	[OldCount],ecx
	mov	[eax+PAGE_SIZE-4],ebx
	mov	[BankList],eax
	xor	eax,eax
	mov	[UseCount],eax
	pop	edx
	pop	ecx
	pop	ebx
	ret

CalcPages:
	xor	eax,eax
	mov	ecx,[BankList]
.1:	jecxz	.ret
	inc	eax
	mov	ecx,[ecx+PAGE_SIZE-4]
	jmp	.1
.ret:	ret


; >> eax - new link
NewLink:
       mov     eax,[FreeLinks]
       test    eax,eax
       jnz     .3
       mov     eax,[OldCount]
       cmp     eax,PAGE_SIZE-sizeof.link_st-4
       jna     .2
       mov     eax,[UseCount]
       cmp     eax,PAGE_SIZE-sizeof.link_st-4
       jna     .1
       call    NewBank
.1:    add     [UseCount],sizeof.link_st
       add     eax,[BankList]
       ret
.2:    add     [OldCount],sizeof.link_st
       add     eax,[OldBank]
       ret
.3:    push    dword [eax]
       pop     dword [FreeLinks]
       ret

; >> eax - new node
NewNode:
       mov     eax,[FreeNodes]
       test    eax,eax
       jnz	.2
       mov     eax,[UseCount]
       cmp     eax,PAGE_SIZE-sizeof.node_st-4
       jna     .1
       call    NewBank
.1:    add     [UseCount],sizeof.node_st
       add     eax,[BankList]
       ret
.2:    push    dword [eax]
       pop     dword [FreeNodes]
       ret

; >> eax - new string
NewString:
       mov     eax,[UseCount]
       cmp     eax,PAGE_SIZE-sizeof.str_st-4
       jna     .1
       call    NewBank
.1:    add     [UseCount],sizeof.str_st
       add     eax,[BankList]
       ret


;   
; eax < link
FreeLink:
       push    [FreeLinks]
       pop     dword [eax]
       mov     [FreeLinks],eax
       ret

; eax < node
FreeNode:
       push    [FreeNodes]
       pop     dword [eax]
       mov     [FreeNodes],eax
       ret


ClearMemory:
       mov     eax,[BankList]
.1:    test    eax,eax
       jz      MemoryInit
       push    dword [eax+PAGE_SIZE-4]
       invoke  LocalFree,eax
;      invoke  VirtualFree,eax,0,MEM_RELEASE
       pop     eax
       jmp     .1


