
format MS COFF

public UpdateString as '_UpdateString@8'
public ClearTree as '_ClearTree@0'
public Find as '_Find@12'
public MemoryInit as '_MemoryInit@0'
public AddString as '_AddString@12'
public TreeRoot as 'TreeRoot@ukk'
public FixEnd as 'FixEnd@ukk'
public isSort as 'isSort@ukk'

include 'c:\fasm\INCLUDE\WIN32A.INC'
include 'struct.inc'
include 'memory_new.inc'


SuffFrom	dd	?	;      . 
TreeRoot	dd	?	;  
LastString	dd	?	;  
FixMode 	dd	?	; <>0    
isSort		dd	?	;   

;     
; >>eax
proc AddString buffer:dword,win_size:dword,user:dword
	mov	ebx,[TreeRoot]
	test	ebx,ebx
	jnz	.1
	call	AddNode
	mov	[TreeRoot],ebx
	mov	[ebx+node_st.suff],ebx
.1:	call	NewString
	mov	[eax+str_st.FullNode],ebx
	mov	ebx,[buffer]
	mov	[eax+str_st.First],ebx
	mov	[eax+str_st.LayText],ebx
	mov	[eax+str_st.EndText],ebx
	xor	ebx,ebx
	mov	[eax+str_st.WinSize],ebx
	mov	[eax+str_st.FullDepth],ebx
	mov	ebx,[user]
	mov	[eax+str_st.user],ebx
	ret
endp


; >>ebx - new node
AddNode:
	call	NewNode
	mov	ebx,eax
	mov	eax,[TreeRoot]
	mov	[ebx+node_st.suff],eax
	push	ecx
	push	edi
	lea	edi,[ebx+node_st.links] 	; links=0   table=0
	xor	eax,eax
	mov	ecx,HASH_SIZE+1
	rep	stosd
	pop	edi
	pop	ecx
	ret


; ebx< node
; esi< start
; eax< end
; ebp< str_id
; >> eax - new link
AddLink:
	push	ebx
	push	ecx
	mov	ecx,eax
	call	NewLink
	mov	[eax+link_st.first],esi
	mov	[eax+link_st.last],ecx
	mov	ecx,dword  [ebx+node_st.links]		;   
	mov	dword [eax+link_st.next],ecx
	mov	[ebx+node_st.links],eax
	xor	ecx,ecx
	mov	[eax+link_st.node],ecx
	mov	[eax+link_st.p1],ecx
	mov	[eax+link_st.p2],ecx
	mov	[eax+link_st.str_id],ebp
	mov	cl,[esi]
	and	cl,HASH_SIZE-1
	lea	ebx,[ebx+ecx*4+node_st.table]
.1:	mov	ecx,[ebx]				;    
	jecxz	.2
	mov	ebx,[ecx+link_st.first]
	mov	bl,byte [ebx]
	cmp	[esi],bl
	sbb	ebx,ebx
	lea	ebx,[ebx*4+ecx+link_st.p2]
	jmp	.1
.2:	mov	[ebx],eax
	pop	ecx
	pop	ebx
	ret


; esi < text
; ecx < depth
; ebx < node
; ebp < str_st
; edx - link
; edi - first
Lay:
	push	esi							;text
	add	esi,ecx
.0:	mov	al,byte [esi]
	mov	edx,HASH_SIZE-1
	and	edx,eax
	mov	edx,[ebx+edx*4+node_st.table]	;      
	jmp	.2
.1:	mov	edi,[edx+link_st.first] 	;    
	cmp	al,[edi]
	jz	.4
	sbb	edi,edi
	mov	edx,[edx+edi*4+link_st.p2]
.2:	test	edx,edx
	jnz	.1
	pop	eax
	mov	[ebp+str_st.FullNode],ebx
	mov	[ebp+str_st.LayText],eax
	neg	eax
	add	eax,esi
	mov	[ebp+str_st.FullDepth],eax
	xor	eax,eax
	call	AddLink
	mov	ecx,[SuffFrom]
	jecxz	.3
	mov	[ecx+node_st.suff],ebx
	xor	ecx,ecx
	mov	[SuffFrom],ecx
.3:	clc
	ret
.4:	mov	eax,[ebp+str_st.EndText]
	dec	eax
	sub	eax,esi 		      ; eax=end-1-offset
	mov	ecx,[edx+link_st.last]
	test	ecx,ecx
	cmovz	ecx,[edx+link_st.str_id]
	cmovz	ecx,[ecx+str_st.EndText]
	sub	ecx,edi 		      ; ecx=link.last-first
	cmp	ecx,eax 	 
	cmovc	eax,ecx
.5:	add	edi,eax
	add	esi,eax 	
	cmp	edi,[edx+link_st.last]	
	cmovz	ebx,[edx+link_st.node]
	jz	.0
	mov	eax,[FixMode]
	test	eax,eax
	jnz	.7
.9:	mov	al,[esi]
	cmp	al,[edi]
	jnz	.7
	pop	eax
	mov	ecx,[SuffFrom]
	jecxz	.6
	mov	[ecx+node_st.suff],ebx
	mov	[SuffFrom],ebx
.6:	stc
	ret
.7:	call	AddNode ; ebx>node
	mov	eax,[edx+link_st.last]
	push	esi
	mov	esi,edi
	call	AddLink 		
	mov	esi,[edx+link_st.node]
	mov	[eax+link_st.node],esi
	mov	esi,[edx+link_st.str_id]
	mov	[eax+link_st.str_id],esi
	pop	esi
	mov	eax,[FixMode]
	test	eax,eax
	jnz	.10
;        xor     eax,eax
	call	AddLink
.10:	pop	eax
	mov	[ebp+str_st.LayText],eax
	neg	eax
	add	eax,esi
	mov	[ebp+str_st.FullDepth],eax
	mov	[ebp+str_st.FullNode],ebx
	mov	ecx,[SuffFrom]
	jecxz	.8
	mov	[ecx+node_st.suff],ebx
.8:	mov	[SuffFrom],ebx
	mov	[edx+link_st.last],edi
	mov	[edx+link_st.node],ebx
	clc
	ret

;    
; esi < text
; eax > string (0)
;; ebx - node
;; edx - link
;; edi - frist
proc Find  ;pattern,size,std_id
	mov	esi,[esp+4]	     ;pattern
	mov	ecx,[esp+8]	     ;size
	mov	ebx,[TreeRoot]
	jecxz	.err
.1:	movzx	eax,byte [esi]
	and	al,HASH_SIZE-1
	mov	edx,[ebx+eax*4+node_st.table]
	mov	al,[esi]
	jmp	.3
.2:	mov	edi,[edx+link_st.first]
	cmp	al,[edi]
	jz	.4
	sbb	edi,edi
	mov	edx,[edx+edi*4+link_st.p2]
.3:	test	edx,edx
	jnz	.2
.err:	xor	eax,eax
	ret	12
.4:	mov	ebx,ecx
	mov	eax,[edx+link_st.last]
	test	eax,eax
	cmovz	eax,[edx+link_st.str_id]
	cmovz	eax,[eax+str_st.EndText]
	sub	eax,edi
	cmp	eax,ecx
	cmovnc	eax,ecx
	xchg	eax,ecx
	push	ecx
	shr	ecx,2
	rep	cmpsb
	pop	ecx
	jnz	.err
	and	ecx,3
	rep	cmpsb
	jnz	.err
	neg	eax
	add	eax,ebx
	xchg	eax,ecx
	mov	ebx,[edx+link_st.node]
	jnz	.1
.ret:	mov	ecx,[esp+12]  ; std_id
	jecxz	.5
	mov	eax,[edx+link_st.str_id]
	mov	[ecx],ebx
.5:	mov	eax,edi
	sub	eax,[esp+8]   ;size
	ret	12
endp

;    
proc FixEnd
	push	ebp
	mov	ebp,[LastString]
	test	ebp,ebp
	jz	.4
	xor	eax,eax
	mov	[SuffFrom],eax
	inc	[FixMode]
	mov	ebx,[ebp+str_st.FullNode]
	mov	ecx,[ebp+str_st.FullDepth]
	mov	esi,[ebp+str_st.LayText]
	jmp	.2
.1:	xor	eax,eax
	cmp	eax,ecx
	sbb	ecx,eax
	mov	ebx,[ebx+node_st.suff]
	push	ebx
	push	ecx
	push	esi
	inc	[ebp+str_st.EndText]
	call	Lay
	dec	[ebp+str_st.EndText]
	pop	esi
	pop	ecx
	pop	ebx
	jc	.3
.2:	inc	esi
	cmp	esi,[ebp+str_st.EndText]
	jc	.1
.3:	dec	[FixMode]
	xor	eax,eax
	mov	[LastString],eax
.4:	pop	ebp
	ret
endp

;     
; ebp - str_st
proc UpdateString	  ;handler,size
	push	ebp
	push	esi	       ;    VC  
	mov	ebp,[esp+12]
	cmp	ebp,[LastString]
	jz	.6
	call	FixEnd
	mov	[LastString],ebp
.6:	mov	ebp,[esp+12]
	mov	[LastString],ebp
	mov	edx,[esp+16] ; size
	mov	esi,[ebp+str_st.EndText]
	add	edx,esi
	xor	eax,eax
	mov	[isSort],eax
	mov	eax,[ebp+str_st.First]
	cmp	eax,[ebp+str_st.EndText]
	jnz	.5
	mov	ebx,[TreeRoot]
	mov	ecx,[ebx+node_st.links]
	jecxz	.0
	dec	[ebp+str_st.LayText]
	jmp	.5
.0:	xor	eax,eax
	call	AddLink
	jmp	.5
.1:	mov	[ebp+str_st.EndText],esi
	xor	eax,eax
	mov	[SuffFrom],eax
	mov	ebx,[ebp+str_st.FullNode]
	mov	ecx,[ebp+str_st.FullDepth]
	mov	esi,[ebp+str_st.LayText]
	jmp	.4
.2:	xor	eax,eax
	cmp	eax,ecx
	sbb	ecx,eax
	mov	ebx,[ebx+node_st.suff]
.3:	push	ebx
	push	ecx
	push	edx
	push	esi
	call	Lay
	pop	esi
	pop	edx
	pop	ecx
	pop	ebx
	jc	.5
.4:	inc	esi
	cmp	esi,[ebp+str_st.EndText]
	jc	.2
.5:	mov	esi,[ebp+str_st.EndText]
	inc	esi
	cmp	esi,edx
	jna	.1
	pop	esi
	pop	ebp
	mov	eax,[TreeRoot]
	ret	8
endp

ClearTree:
     jmp ClearMemory







