//! \file ukk.h

#include<string.h>

struct link_st;

//!   
struct str_st{
	char *first;		//!<  
	char *end;			//!< 
	int win_size;		//!<   (  )
	unsigned long user;	//!<  
};

//!  
struct node_st{
	node_st *suff;		//!<  
	link_st *links;		//!<   
};

//!  
struct link_st{
	link_st *next;		//!< .   
	char *first;		//!<   
	char *last;			//!<    (0 -   )
	node_st *node;		//!<     
	str_st *str;		//!<   
	unsigned long user;	//!<  
};

//!  
//! \param txt  
//! \param win    ( )
//! \param use   
//! \result     
extern "C" _CRTIMP str_st*  _stdcall AddString(char* txt,int win=0,void*use=0);

//!    
//! \param h        
//! \param size   
extern "C" _CRTIMP node_st* _stdcall UpdateString(str_st* h,int size);

//!  
extern "C" _CRTIMP void     _stdcall MemoryInit();

//!  
extern "C" _CRTIMP void     _stdcall ClearTree();

//!    
//! \param  text     
//! \param  size     
//! \retval str_st     (   0)
//! \result        ( 0 -   )
extern "C" _CRTIMP char*    _stdcall Find(char* text,int size,str_st**);

//!   
extern "C" _CRTIMP int      _stdcall CalcNodes();

//!   
extern "C" _CRTIMP int      _stdcall CalcLinks();

//!   
extern "C" _CRTIMP int      _stdcall CalcLeafs();

//!    
extern "C" _CRTIMP int      _stdcall CalcLeafsSize();

//!     
//! \param str    
//! \param ref      (   0)
//! \result   
extern "C" _CRTIMP int      _stdcall MaxReentrant(str_st* str,char** ref);


//!       
extern "C" _CRTIMP _stdcall SortLinks();


//!      (   )
node_st *MakeTree(char* txt,int size=0) 
{ 
	if(!size) size=strlen(txt);
	return UpdateString(AddString(txt,0,0),size); 
}

