format MS COFF
include 'c:\fasm\INCLUDE\WIN32A.INC'
include 'struct.inc'

public CalcNodes as '_CalcNodes@0'
public CalcLinks as '_CalcLinks@0'
public CalcLeafs as '_CalcLeafs@0'
public CalcLeafsSize as '_CalcLeafsSize@0'
public MaxReentrant as '_MaxReentrant@8'
public SortLinks as '_SortLinks@0'

extrn 'TreeRoot@ukk' as TreeRoot
extrn 'FixEnd@ukk' as FixEnd
extrn 'isSort@ukk' as isSort

;  
; esi<  
WalkLinks:
     xor     ecx,ecx
     mov     edx,dword [TreeRoot]
; ecx< depth
; edx< node
; edi< proc
WalkLinks_sub:
	mov	ebx,[edx+node_st.links]
	jmp	.2
.1:	call	esi
	push	edx
	mov	edx,[ebx+link_st.node]
	test	edx,edx
	jz	.3
	push	ebx
	push	ecx
	add	ecx,[ebx+link_st.last]
	sub	ecx,[ebx+link_st.first]
	call	WalkLinks_sub
	pop	ecx
	pop	ebx
.3:	pop	edx
	mov	ebx,[ebx+link_st.next]
.2:	test	ebx,ebx
	jnz	.1
	ret


;  
WalkNodes:
	xor	ebx,ebx
	xor	ecx,ecx
	mov	edx,dword [TreeRoot]
; ebx< parent link
; ecx< depth
; edx< node
; edi< proc
WalkNodes_sub:
	push	ecx
	push	edx
	push	esi
	call	esi
	pop	esi
	pop	edx
	pop	ecx
	mov	ebx,[edx+node_st.links]
	jmp	.2
.1:	push	edx
	mov	edx,[ebx+link_st.node]
	test	edx,edx
	jz	.3
	push	ebx
	push	ecx
	add	ecx,[ebx+link_st.last]
	sub	ecx,[ebx+link_st.first]
	call	WalkNodes_sub
	pop	ecx
	pop	ebx
.3:	pop	edx
	mov	ebx,[ebx+link_st.next]
.2:	test	ebx,ebx
	jnz	.1
	ret

IncEax: inc	eax
	ret

;   
proc CalcLeafs
      xor   eax,eax
      xor   edi,edi
      mov   esi,.1
      jmp   WalkLinks
.1:   cmp   edi,[ebx+link_st.last]
      cmc
      adc   eax,edi
      ret
endp

;   
proc CalcNodes
     xor   eax,eax
     mov   esi,IncEax
     jmp   WalkNodes
endp

;   
proc CalcLinks
     xor   eax,eax
     mov   esi,IncEax
     jmp   WalkLinks
endp


;    
proc CalcLeafsSize
       xor    eax,eax
       mov    esi,.1
       jmp    WalkLinks
.1:    mov    edx,[ebx+link_st.last]
       test   edx,edx
       jnz    .ret
       mov    edx,[ebx+link_st.str_id]
       mov    edx,[edx+str_st.EndText]
       add    eax,edx
       sub    eax,[ebx+link_st.first]
.ret:  ret
endp

;    ,   
MaxReentrant:  ; str_id,ref
       call   FixEnd
       push   ebp
       mov    ebp,esp
       xor    eax,eax
       mov    esi,.1
       call   WalkNodes
       pop    ebp
       ret    8
.1:    test   ebx,ebx
       jz     .5
       push   ebx
       mov    ebx,[edx+node_st.links]
       xor    edx,edx
       jmp    .4
.2:    mov    edi,[ebx+link_st.str_id]
       cmp    edi,[ebp+8]	; str_id
       jnz    .3
       inc    edx
       cmp    dl,2
       jz     .6
.3:    mov    ebx,[ebx+link_st.next]
.4:    test   ebx,ebx
       jnz    .2
       pop    ebx
.5:    ret
.6:    pop    ebx
       cmp    eax,ecx
       jnc    .5
       mov    eax,ecx
       mov    ecx,[ebp+12]	 ; ref
       jecxz  .5
       mov    edi,[ebx+link_st.last]
       sub    edi,eax
       mov    [ecx],edi
       ret

proc SortLinks
       mov   eax,dword [isSort]
       test  eax,eax
       jnz   .ret
       inc   dword [isSort]
       mov   esi,.1
       jmp   WalkNodes
.1:    sub   esp,256*4+32
       mov   edi,esp
       xor   eax,eax
       xor   ecx,ecx
       mov   cl,8
       rep   stosd	;      256 ,   
       push  edx
       mov   ebx,[edx+node_st.links]
       jmp   .3
.2:    mov   edx,[ebx+link_st.first]	;     
       mov   cl,[edx]
       mov   [edi+ecx*4],ebx
       xor   edx,edx
       inc   edx
       rol   edx,cl
       shr   ecx,5
       or    [edi+ecx*4-32],edx
       mov   ebx,[ebx+link_st.next]
.3:    test  ebx,ebx
       jnz   .2
       pop   edx
       xor   eax,eax
       xor   ecx,ecx
       mov   cl,8
       lea   ebx,[edi+256*4]
       mov   [edx+node_st.links],eax
       stc
       rcr   eax,1
.4:    sub   edi,4
       mov   esi,[edi]
       test  esi,esi
       jnz   .8
       sub   ebx,32*4
       jmp   .7
.8:    push  ecx
.5:    sub   ebx,4
       test  [edi],eax
       jz    .6
       mov   ecx,[ebx]
       mov   esi,[edx+node_st.links]
       mov   [ecx+link_st.next],esi
       mov   [edx+node_st.links],ecx
.6:    ror   eax,1
       jnc   .5
       pop   ecx
.7:    loop  .4
       add   esp,256*4+32
.ret:  ret
endp



